//Particle.h

#ifndef PARTICLE_H
#define PARTICLE_H
#include <math.h>
#include "Vector.h"

class Particle 
{
	private:
		float	fMass;			// Masse
		float	fInvMass;		// Inverse Masse
		Vector	vPosition;		// Position
		Vector	vVelocity;		// Geschwindigkeit
		Vector	vAcceleration;	// Beschleunigung
		Vector	vForces;		// Kraft
		Vector	vDisplacement;	// Verschiebung
		Vector	vDrag;			// Luft-Widerstand
		Vector	vWind;			// Wind

	public:
		bool	bFixed;			// Angabe, ob Partikel beweglich oder fest

		/** Konstruktor und Default-Konstruktor von Particle
		*/
		Particle (float m, float invm, Vector &p, Vector &v, Vector &a, Vector &f, Vector &d, Vector &dr, Vector &w, bool fx);
		Particle ();			

		/**set-Methoden
		*/

		inline void setMass (float m)
		{
			fMass = m;
		}

		inline void setInvMass ()
		{
			fInvMass = 1 / fMass;
		}

		inline void setPosition (Vector &p)
		{
			vPosition.setX (p.getX());
			vPosition.setY (p.getY());
			vPosition.setZ (p.getZ());
		}

		inline void setVelocity (Vector &v)
		{
			vVelocity.setX (v.getX());
			vVelocity.setY (v.getY());
			vVelocity.setZ (v.getZ());
		}

		inline void setAcceleration (Vector &a)
		{
			vAcceleration.setX (a.getX());
			vAcceleration.setY (a.getY());
			vAcceleration.setZ (a.getZ());
		}

		inline void setForces (Vector &f)
		{
			vForces.setX (f.getX());
			vForces.setY (f.getY());
			vForces.setZ (f.getZ());
		}

		inline void setDisplacement (Vector &d)
		{
			vDisplacement.setX (d.getX());
			vDisplacement.setY (d.getY());
			vDisplacement.setZ (d.getZ());
		}

		inline void setDisplacement (float a, float b, float c)
		{
			vDisplacement.setX (a);
			vDisplacement.setY (b);
			vDisplacement.setZ (c);
		}


		inline void setDrag (Vector &dr)
		{
			vDrag.setX (dr.getX());
			vDrag.setY (dr.getY());
			vDrag.setZ (dr.getZ());
		}

		inline void setWind (Vector &w)
		{
			vWind.setX (w.getX());
			vWind.setY (w.getY());
			vWind.setZ (w.getZ());
		}


		inline void setHeight (float h)
		{
			vPosition.setY (h);
		}


		/** get-Methoden
		*/

		inline float getMass () const 
		{
			return fMass;
		}

		inline float getInvMass () const 
		{
			return fInvMass;
		}

		inline Vector getPosition () const 
		{
			return vPosition;
		}

		inline Vector getVelocity () const 
		{
			return vVelocity;
		}

		inline Vector getAcceleration () const 
		{
			return vAcceleration;
		}

		inline Vector getForces () const 
		{
			return vForces;
		}
		
		inline Vector getDisplacement () const 
		{
			return vDisplacement;
		}

		inline Vector getDrag () const 
		{
			return vDrag;
		}

		inline Vector getWind () const 
		{
			return vWind;
		}

		inline float getHeight () const 
		{
			return vPosition.getY();
		}


		/** add-Methode fr die Krfte
		*/

		inline void addForces (Vector &f) 
		{
			vForces.setX (f.getX() + vForces.getX());
			vForces.setY (f.getY() + vForces.getY());
			vForces.setZ (f.getZ() + vForces.getZ());
		}


};

#endif