// Spring.h

#ifndef SPRING_H
#define SPRING_H
#include <math.h>
#include "Vector.h"
#include "Particle.h"


class Spring
{
	private:	
		Particle* mBegin;	// Zeiger auf erstes Particle (Anfangspunkt der Feder)
		Particle* mEnd;		// Zeiger auf zweites Particle (Endpunkt der Feder)

		float mLength;		// Ruhelnge der Feder
		float fSpringConst;	// Federkonstante
		float fDamping;		// Dmpfung

	public:
		/** Default-Konstruktor und Konstruktor mit bekannten Particles und Werten von Spring
		*/
		Spring();

		Spring( Particle* first, Particle* second, float sc, float d );
		
		/** set-Methoden
		*/

/*		inline void setLength (float L)
		{
			mLength = L;
		}
*/
		inline void setSpringConst (float sc)
		{
			fSpringConst = sc;
		}

		inline void setDamping (float d)
		{
			fDamping = d;
		}


		/** get-Methoden
		*/

		inline float getLength () const 
		{
			return mLength;
		}

		inline float getSpringConst () const 
		{
			return fSpringConst;
		}

		inline float getDamping () const 
		{
			return fDamping;
		}

		Particle* getBeginParticle () 
		{
			return mBegin;
		}

		Particle* getEndParticle () 
		{
			return mEnd;
		}

};

#endif